#include "logicthd.h"
#include "framedir.h"
#define AIXFILE 0
#define UTEFILE 1

/*
 * completion codes
 */
#define RV_BADFORMAT -1
#define RV_EOF       0
#define RV_GOOD      1
#define RV_UNDEFINED 2
#define RV_ISHOOKID  4
#define RV_TB0       5
#define BILLION 1000000000
#define MAX_NUM_CPUS 16
#define HOOKTOID(hw)    (((hw) >> 20) & 0xFFF)

#define LOGFILE_DFLT   "/usr/adm/ras/trcfile"

typedef struct lblock {
  int lb_currentry;
  int lb_firstentry;
  int lb_lastentry;
  int lb_startoffset;
  int lb_endoffset;
  int lb_icflg;
};

#define MAX_EVENT_BUFFER_SIZE 5008
/*
 * UTENODE structure
 */
typedef struct letht {
  int nodeid;		        /* node ID */
  int Asecond;	           /* real clock in CLKT */
  int Ananosecond;        /* real clock in CLKT */
  unsigned Prevstamp;          /* AIX timestamp */
  FILE *infp;		        /* File pointer */
  int Logidx;		        /* current file offset */
  struct lblock Lb;	     /* lblock */
  struct trc_log *Logp;	  /* Logp */
  int Eventsize;          /* record size */
  char Eventbuf[MAX_EVENT_BUFFER_SIZE];    /* max length of event */
  int Threadflg;
  int initconver;
  int TrcXfact;
  int TrcXint;
  int switch_freq;        /* switch network frequency */
  long long count;        /* a space reserved for number of records */
  double elapsedTime;     /* a space reserved for total elapsed time */
  short int ncpus;        /* number of CPUs in the node: only for convert */
  short int hasdispatch;  /* 106 events: only for convert*/
  int AIXTraceVersion;    /* AIX trace version */

/* the following for merging */
  int Hsec;		           /* header second in TRCON, merging w/o gclock */
  double basetime;        /* base local real time */
  double globaltime;      /* global real time */
  struct letht *left;     /* CLKT pointer */
  struct letht *right;    /* CLKT pointer */
  struct letht *back;     /* CLKT pointer */
  int bal;                /* CLKT balance factor */

/* the following for handling pid/tid issues */
  int cpuid;
  int aixpid[MAX_NUM_CPUS];
  int oldpid[MAX_NUM_CPUS];   /* previous AIX process ID */
  int aixtid[MAX_NUM_CPUS];
  int oldtid[MAX_NUM_CPUS];   /* previous AIX thread ID */
  short int ltid[MAX_NUM_CPUS];     /* logical thread ID */
  short int oldltid[MAX_NUM_CPUS];  /* previous logical thread ID */
  char swflag[MAX_NUM_CPUS/8];/* logic thread switched away */
  int num_ltids;              /* number of logical thread IDs */
  interval_fixed_header *head;/* used for individual input file */
  interval_header *header;    /* used for merged input file */
  frame_directory *framedp;   /* frame directory pointer */
  double stime[MAX_NUM_CPUS]; /* start time */
} UTENODE;

